#include "keyb.h"
#include "key_code.h"
#include "3df_fig.h"
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <graphics.h>
#include <process.h>
#include <math.h>

// ang_dir (0-360) east=0, north=90, west=180, south=270.
// ang_wing 0=horz, 90=turning left, -90=turning right.
// ang_nose 0=horz, 90=up, -90=down

#define VENARR 0
#define VENABJ 479
#define VENDER 639
#define VENIZQ 0

#define PI M_PI

#define MAXP 100


void IniciaGraficos(void);
void figure3a(float fig[], float atx, float aty, float atz, double ang_dir,
	double ang_wing, double ang_nose);
void teclado(void);
void element(void);
void help(void);


double cos_fiy, sen_fiy;
double cos_fiz, sen_fiz;
double cos_fix, sen_fix;
float x0,y0,z0, xg,yg,zg;


int Vy=-400,Vx=0,Vz=10;

float plane_wing=0, plane_nose=0, plane_dir=0;

void main(void) {


	IniciaGraficos();

	IniKeyb();
	help();
	gotoxy(1,30);
	printf("Press SPACE to START.");
	while(!key[KEY_ESPACIO] && !key[KEY_ESC]);


	teclado();

	CloseKeyb();
	closegraph();
}

void teclado(void) {
#define ZOFF 10
	float fi=0,dd=0,nn=0,ww=0;
	float x=0, y=-340, z=ZOFF;
	int c,flip;

	float step_fi=.03;
	float step=0;

	float v_wing_flaps=0;
	float v_tail_flaps=0;
	float v_dir_flap=0;

	int scrx;
	int scry;


	for(;;) {
		if(key[KEY_ESC]) return;

		if(key[KEY_Q]) { step+=.1; if(!key[KEY_PAD_ENTER] && step>4.0) step=4.0;  }
		if(key[KEY_A]) { step-=.1; if(!key[KEY_PAD_ENTER] && step<0.0) step=.0; }

		//if(key[KEY_PAD_9]) plane_dir += step_fi;
		//if(key[KEY_PAD_6]) plane_dir -= step_fi;

		//if(key[KEY_PAD_8]) plane_nose += step_fi;
		//if(key[KEY_PAD_5]) plane_nose -= step_fi;

		//if(key[KEY_PAD_7]) plane_wing += step_fi;
		//if(key[KEY_PAD_4]) plane_wing -= step_fi;

		if(key[KEY_ESPACIO]) {
			plane_wing=0; plane_nose=0; plane_dir=0;
			x=0; y=-340; z=ZOFF;
			step = 0;
		}

		//if(key[KEY_Z]) fi+=.1;
		//if(key[KEY_X]) fi-=.1;



		if(key[KEY_CUR_IZQ]) v_wing_flaps += .1;
		if(key[KEY_CUR_DER]) v_wing_flaps -= .1;

		if(key[KEY_CUR_ABJ]) v_tail_flaps += .1;
		if(key[KEY_CUR_ARR]) v_tail_flaps -= .1;

		if(key[KEY_W]) v_dir_flap -= .1;
		if(key[KEY_E]) v_dir_flap += .1;

		if(key[KEY_F1]) help();




		plane_wing += v_wing_flaps/10;
		plane_nose += v_tail_flaps/10;
		plane_dir += .05*cos(v_dir_flap+PI/2) - 0.05*cos(plane_wing+PI/2);
		plane_wing -= plane_wing/16;
		plane_nose -= plane_nose/6;


		x += step * cos(plane_dir+PI/2)+ step * cos(plane_dir+PI/2) * cos(plane_nose );
		y += step * sin(plane_dir+PI/2)+ step * sin(plane_dir+PI/2) * cos(plane_nose );
		z += 5*step * sin(plane_nose);



// wing flaps
		*p41y = *p40y = -2 - cos(v_wing_flaps);
		*p41z = *p40z =  2 + sin(v_wing_flaps);

		*p43y = *p42y = -2 - cos(v_wing_flaps);
		*p43z = *p42z =  2 - sin(v_wing_flaps);

// tail flaps
		*p46y = *p47y = *p44y = *p45y = -15 - cos(v_tail_flaps);
		*p46z = *p47z = *p44z = *p45z =  sin(v_tail_flaps);

// dir flap
		*p48x = *p49x = sin(v_dir_flap);
		*p48y = *p49y = -15 - cos(v_dir_flap);

		v_wing_flaps -= v_wing_flaps/10;
		v_tail_flaps -= v_tail_flaps/10;
		v_dir_flap -= v_dir_flap/10;


		//delay(20);
		//cleardevice();

		#define COS(X) (cos(X)) //(PI/2-(X))/(PI/2)
		#define SIN(X) (sin(X)) //(X/(PI/2))
		ww = plane_wing;
		nn = plane_nose;//*COS(ww)-plane_dir*SIN(ww);
		dd = plane_dir;///*COS(ww)+plane_nose*SIN(ww);

		//plane_nose = plane_wing = plane_dir = 0;
#define VX .5
		if(y>-380.0) {
			figure3a(plane , x, y, z, ww, nn, dd);
		} else {
			delay(20);
			cleardevice();
		}


		// RADAR

		setcolor(DARKGRAY);
#define R 50
		//line(R,0,R,2*R);
		//line(0,R,2*R,R);
		#define rox (R+140)
		#define roy (R+350)
		circle(rox, roy, R);

		#define ALPHA .9
		line(rox, roy, rox - R*cos(ALPHA), roy-R*sin(ALPHA));
		line(rox, roy, rox + R*cos(ALPHA), roy-R*sin(ALPHA));

		#define cSCALE 200.0
		scrx = x/cSCALE;
		scry = (y+340)/cSCALE;
		if(scry*scry+scrx*scrx < R*R) {
			setcolor(LIGHTRED);
			line(rox+scrx-1, roy-scry, rox+scrx+1, roy-scry);
			line(rox+scrx, roy-scry-1, rox+scrx, roy-scry+1);
		}


		// COMPASS


		#define cox (rox + R+ R/2+R)
		#define coy (roy)
		setcolor(DARKGRAY);
		circle(cox,coy,R);
		setcolor(LIGHTGREEN);
		line(cox,coy, .5+cox-R*.8*cos(plane_dir-(PI/2)), .5+coy+R*.8*sin(plane_dir-(PI/2)));

		#define aox (cox+R+ R/2+R)
		#define aoy (coy)
		setcolor(DARKGRAY);
		circle(aox,aoy,R);
		setcolor(LIGHTGREEN);
		#define aSCALE1  100.0
		#define aSCALE2  (10.0*aSCALE1)
		#define aSCALE3  (10.0*aSCALE2)
		#define aSCALE4  (10.0*aSCALE3)
		setcolor(LIGHTGREEN);
		line(aox,aoy,
			(aox - (R*.8) * cos(  (z-ZOFF)/aSCALE1 + (PI/2.0)  ))+.5,
			(aoy - (R*.8) * sin(  (z-ZOFF)/aSCALE1 + (PI/2.0)  ))+.5
		);
		setcolor(YELLOW);
		line(aox,aoy,
			(aox - (R*.6) * cos(  (z-ZOFF)/aSCALE2 + (PI/2.0)  ))+.5,
			(aoy - (R*.6) * sin(  (z-ZOFF)/aSCALE2 + (PI/2.0)  ))+.5
		);
		setcolor(WHITE);
		line(aox,aoy,
			(aox - (R*.4) * cos(  (z-ZOFF)/aSCALE3 + (PI/2.0)  ))+.5,
			(aoy - (R*.4) * sin(  (z-ZOFF)/aSCALE3 + (PI/2.0)  ))+.5
		);
		//printf("z=%f",z);

//		act_fire();

//		#define GR *180/PI
//		gotoxy(1,1);
//		printf("wing=%2.f  nose=%2.f   dir=%2.f  fi=%2.f  \n", plane_wing GR, plane_nose GR, plane_dir GR, fi GR);





	}
}
/*
void new_fire(void) {
	int n;

	for(n=0; n<MAX_BULLETS; n++) {
		if(bull[n].count) {
			bull[n].count = 200;
			bull[n].x = bull[n].incx;
			bull[n].y = bull[n].incy;
			bull[n].z = bull[n].incz;


void act_fire(void) {
	int n;

	for(n=0; n<MAX_BULLETS; n++) {
		if(bull[n].count) {
			figure3a(bullet, bull[n].x, bull[n].y, bull[n].z, bull[n].w,
				bull[n].n, bull[n].d);
			bull[n].count--;
			bull[n].x += bull[n].incx;
			bull[n].y += bull[n].incy;
			bull[n].z += bull[n].incz;
		}
	}
}
*/
void figure3a(float fig[], float atx, float aty, float atz, double fiy,
	double fix, double fiz) {

// fig[]		 apunta a la cadena que define la figura
// atx, aty, atz		coordenadas donde situar la figura
// fix,y,z;  giro sobre el eje z (rad)

 static float x[MAXP], y[MAXP];   // buffer de clculo
 //int radio;
 int escala;
 int np;		// nmero de puntos de la figura
 int nl;		// nmero de lneas de la figura
 int index=1;

 int i;
 float	ygVy;

 cos_fiy=cos(fiy); sen_fiy=sin(fiy);
 cos_fiz=cos(fiz); sen_fiz=sin(fiz);
 cos_fix=cos(fix); sen_fix=sin(fix);

 //radio = fig[index++];
// if( !en_campo_vision( atx, aty, atz, radio ) ) return(0);

 escala = fig[index++];     /* lee escala */
 np = fig[index++];		/* lee nmero de puntos */

 for( i=0 ; i < np ; i++ )
 {
	x0= escala * fig[index++];
	y0= escala * fig[index++];
	z0= escala * fig[index++];

// rotate wing  (y axis)
	xg = x0 * cos_fiy + z0 * -sen_fiy;
	yg = y0;
	zg = x0 * sen_fiy + z0 *  cos_fiy;

	x0=xg; y0=yg; z0=zg;

// rotate nose  (x axis)
	xg = x0;
	yg = y0 * cos_fix + z0 * -sen_fix;
	zg = y0 * sen_fix + z0 *  cos_fix;

	x0=xg; y0=yg; z0=zg;

// rotate dir  (z axis)
	xg = x0 * cos_fiz + y0 * -sen_fiz;
	yg = x0 * sen_fiz + y0 *  cos_fiz;
	zg = z0;

//	x0=xg; y0=yg; z0=zg;

// translation
	xg += atx;
	yg += aty;
	zg += atz;

  ygVy = yg - Vy; if( ygVy == 0 ) ygVy = .0000001;

	x[i] = ( VENDER - VENIZQ ) / 2 + Vx + Vy * (Vx-xg) / (ygVy);
	y[i]  = ( VENABJ - VENARR ) / 2 + Vz + Vy *  (-Vz+zg) / (ygVy);

 }

 nl = fig[index++];        /* lee nmero de lneas */

// printf("%i", nl);

 // pinta lneas
// setviewport( VENIZQ, VENARR, VENDER, VENABJ, 0 );

 delay(20);
 cleardevice();
		 //wait_vertical_retrace
//		 while(!(0x08 & inport(0x3DA))) ;
//		 while(0x08 & inport(0x3DA)) ;

 for( i=0 ; i<nl ; i++)
 {
  int from = fig[index++];
  int to = fig[index++];
	if( from == COLOR ) { setcolor( to ); i-- ;continue; }

	line( x[from], y[from], x[to], y[to] );
 }

}


void IniciaGraficos(void) {

	 int gdriver = DETECT, gmode, errorcode;
	 initgraph(&gdriver, &gmode, "");
	 errorcode = graphresult();

	 if (errorcode != grOk)  // an error occurred
   {
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Check if the file 'egavga.bgi' is in the current directory.\n");
		printf("Press any key.");
		getch();
		exit(1);             /* return with error code */
	}

}





void help(void) {
	gotoxy(1,1);
	printf("Airplane simulator v1.1\n\r");
	printf("Demonstrates basic use of control surfaces, radar, compass and altimeter.\n\r");
	printf("Programmed by Manuel Guilln Gonzlez.");gotoxy(wherex()+6,wherey());
	printf("<m.guillen-gonzalez@uclan.ac.uk>\n\r");
	printf("\n\r");
	printf("-------------------------------------------------------------- \n\r");
	printf("Key          Control Surface        Action  \n\r");
	printf("-------------------------------------------------------------- \n\r");
	printf("LEFT, RIGHT     Ailerons           Roll      \n\r");
	printf("W, E            Rudder             Yaw       \n\r");
	printf("DOWN, UP        Elevator           Pitch     \n\r");
	printf("Q, A            Thrust             Engine    \n\r");
	printf("\n\r");
	printf("F1                                 Display this help\n\r");
	printf("ESC                                Exit\n\r");
	printf("SPACE BAR                          Return to start position.\n\r");
	printf("\n\r");
	printf("----------------------------------------------- \n\r");
	printf("Instrument   Use\n\r");
	printf("----------------------------------------------- \n\r");
	printf("Radar        Shows position of airplane.\n\r");
	printf("Compass      Shows orientation of airplane.\n\r");
	printf("Altimeter    Shows altitude of airplane.\n\r");
	printf("\n\r");
	printf("-------------------------------------------------------------- \n\r");
	printf("First lesson:\n\r");
	printf("-------------------------------------------------------------- \n\r");
	printf("Get familiar with Aileron, Rudder and Elevator Controls.\n\r");
	printf("Then press 'E' to move forward.\n\r");
	printf("Press 'SPACE BAR' at any time to return the airplane to the start point.\n\r");
//	printf("\n\r");

	if(key[KEY_F2]) {
		printf("Use PAD_ENTER + 'E' or 'D' to exceed speed limits.\n\r");
	}


	while(key[KEY_F1]);

}